From f6fb72fcf4682fca67e202f94d99cf2096b37534 Mon Sep 17 00:00:00 2001
From: Clement CHESNIN <clement.chesnin@gmail.com>
Date: Thu, 19 Nov 2009 18:04:22 +0100
Subject: [PATCH] audiobargraph 191109

---
 compat/strtok_r.c                      |   52 ++
 configure.ac                           |    7 +-
 include/vlc_fixups.h                   |    4 +
 modules/audio_filter/Modules.am        |    1 +
 modules/audio_filter/audiobargraph_a.c |  336 +++++++++++
 modules/video_filter/Modules.am        |    1 +
 modules/video_filter/audiobargraph_v.c |  948 ++++++++++++++++++++++++++++++++
 7 files changed, 1347 insertions(+), 2 deletions(-)
 create mode 100755 compat/strtok_r.c
 create mode 100755 modules/audio_filter/audiobargraph_a.c
 create mode 100755 modules/video_filter/audiobargraph_v.c

diff --git a/compat/strtok_r.c b/compat/strtok_r.c
new file mode 100755
index 0000000..b1968c7
--- /dev/null
+++ b/compat/strtok_r.c
@@ -0,0 +1,52 @@
+/*****************************************************************************
+ * strtok_r.c: POSIX strtok_r() replacement
+ *****************************************************************************
+ * Copyright  1998-2009 the VideoLAN project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include <string.h>
+
+char *strtok_r(char *s, const char *delim, char **save_ptr)
+{
+	char *token;
+
+	if (s == NULL)
+		s = *save_ptr;
+
+	/* Scan leading delimiters. */
+	s += strspn (s, delim);
+	if (*s == '\0')
+		return NULL;
+
+	/* Find the end of the token. */
+	token = s;
+	s = strpbrk (token, delim);
+	if (s == NULL)
+		/* This token finishes the string. */
+		*save_ptr = strchr (token, '\0');
+	else
+	{
+		/* Terminate the token and make *SAVE_PTR point past it. */
+		*s = '\0';
+		*save_ptr = s + 1;
+	}
+	return token;
+}
diff --git a/configure.ac b/configure.ac
index 89b4b66..32449e8 100644
--- a/configure.ac
+++ b/configure.ac
@@ -576,7 +576,7 @@ need_libc=false
 dnl Check for usual libc functions
 AC_CHECK_FUNCS([gettimeofday isatty sigrelse getpwuid_r memalign posix_memalign if_nametoindex getenv putenv setenv ctime_r daemon fork lstat posix_fadvise posix_madvise uselocale])
 AC_CHECK_FUNCS(fcntl)
-AC_REPLACE_FUNCS([asprintf atof atoll getcwd getpid gmtime_r lldiv localtime_r rewind strcasecmp strcasestr strdup strlcpy strncasecmp strndup strnlen strsep strtof strtoll vasprintf swab])
+AC_REPLACE_FUNCS([asprintf atof atoll getcwd getpid gmtime_r lldiv localtime_r rewind strcasecmp strcasestr strdup strlcpy strncasecmp strndup strnlen strsep strtof strtok_r strtoll vasprintf swab])
 AC_CHECK_FUNCS([stricmp strnicmp])
 AC_CHECK_FUNCS(fdatasync,,
   [AC_DEFINE(fdatasync, fsync, [Alias fdatasync() to fsync() if missing.])
@@ -733,7 +733,7 @@ AC_CHECK_LIB(m,pow,[
   VLC_ADD_LIBS([avcodec avformat swscale postproc ffmpegaltivec i420_rgb faad twolame equalizer spatializer param_eq libvlccore freetype mod mpc dmo quicktime realaudio realvideo opengl],[-lm])
 ])
 AC_CHECK_LIB(m,sqrt,[
-  VLC_ADD_LIBS([headphone_channel_mixer normvol speex mono colorthres extract],[-lm])
+  VLC_ADD_LIBS([headphone_channel_mixer normvol audiobargraph_a speex mono colorthres extract],[-lm])
 ])
 AC_CHECK_LIB(m,ceil,[
   VLC_ADD_LIBS([hotkeys mosaic swscale_omap],[-lm])
@@ -1219,6 +1219,7 @@ VLC_ADD_PLUGIN([blend])
 VLC_ADD_PLUGIN([scale])
 VLC_ADD_PLUGIN([vmem])
 VLC_ADD_PLUGIN([logo])
+VLC_ADD_PLUGIN([audiobargraph_v])
 VLC_ADD_PLUGIN([magnify])
 VLC_ADD_PLUGIN([puzzle])
 VLC_ADD_PLUGIN([colorthres])
@@ -1272,6 +1273,7 @@ if test "${SYS}" != "mingwce"; then
   VLC_ADD_PLUGIN([dolby_surround_decoder])
   VLC_ADD_PLUGIN([headphone_channel_mixer])
   VLC_ADD_PLUGIN([normvol])
+  VLC_ADD_PLUGIN([audiobargraph_a])
   VLC_ADD_PLUGIN([equalizer])
   VLC_ADD_PLUGIN([param_eq])
   VLC_ADD_PLUGIN([scaletempo])
@@ -1290,6 +1292,7 @@ if test "${SYS}" = "mingwce"; then
   VLC_ADD_PLUGIN([simple_channel_mixer])
   VLC_ADD_PLUGIN([headphone_channel_mixer])
   VLC_ADD_PLUGIN([normvol])
+  VLC_ADD_PLUGIN([audiobargraph_a])
   VLC_ADD_PLUGIN([a52tospdif])
   VLC_ADD_PLUGIN([dtstospdif])
   VLC_ADD_PLUGIN([i420_yuy2])
diff --git a/include/vlc_fixups.h b/include/vlc_fixups.h
index 512b785..e0ebdb0 100644
--- a/include/vlc_fixups.h
+++ b/include/vlc_fixups.h
@@ -146,6 +146,10 @@ char *getcwd (char *buf, size_t size);
 pid_t getpid (void);
 #endif
 
+#ifndef HAVE_STRTOK_R
+char *strtok_r(char *, const char *, char **);
+#endif
+
 #ifdef __cplusplus
 } /* extern "C" */
 #endif
diff --git a/modules/audio_filter/Modules.am b/modules/audio_filter/Modules.am
index 25a830f..69303b9 100644
--- a/modules/audio_filter/Modules.am
+++ b/modules/audio_filter/Modules.am
@@ -1,6 +1,7 @@
 SUBDIRS = channel_mixer converter resampler spatializer
 SOURCES_equalizer = equalizer.c equalizer_presets.h
 SOURCES_normvol = normvol.c
+SOURCES_audiobargraph_a = audiobargraph_a.c
 SOURCES_param_eq = param_eq.c
 SOURCES_scaletempo = scaletempo.c
 SOURCES_chorus_flanger = chorus_flanger.c
diff --git a/modules/audio_filter/audiobargraph_a.c b/modules/audio_filter/audiobargraph_a.c
new file mode 100755
index 0000000..4973ded
--- /dev/null
+++ b/modules/audio_filter/audiobargraph_a.c
@@ -0,0 +1,336 @@
+/*****************************************************************************
+ * audiobargraph_a.c : audiobargraph audio plugin for vlc
+ *****************************************************************************
+ * Copyright (C) 2002-2006 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Clement CHESNIN <clement.chesnin@gmail.com>
+ *          Philippe COENT <philippe.coent@tdf.fr>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+/*****************************************************************************
+ * Preamble
+ *****************************************************************************/
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <vlc_common.h>
+#include <vlc_plugin.h>
+#include <vlc_aout.h>
+#include <vlc_filter.h>
+
+#include <vlc_network.h>
+#include <math.h>
+
+
+
+#define ADDRESS_TEXT N_("TCP address to use (default localhost)")
+#define ADDRESS_LONGTEXT N_("TCP address to use to communicate with the video "\
+                "part of the Bar Graph (default localhost)." \
+                "In the case of bargraph incrustation, use localhost." )
+#define PORT_TEXT N_("TCP port to use (default 12345)")
+#define PORT_LONGTEXT N_("TCP port to use to communicate with the video "\
+                "part of the Bar Graph (default 12345)." \
+                "Use the same port as the one used in the rc interface." )
+#define BARGRAPH_TEXT N_("Defines if BarGraph information should be send (default 1)")
+#define BARGRAPH_LONGTEXT N_("Defines if BarGraph information should be send. "\
+                "1 if the information should be sent, 0 otherwise (default 1)." )
+#define BARGRAPH_REPETITION_TEXT N_("Sends the barGraph information every n audio packets (default 4)")
+#define BARGRAPH_REPETITION_LONGTEXT N_("Defines how often the barGraph information should be sent. "\
+                "Sends the barGraph information every n audio packets (default 4)." )
+#define SILENCE_TEXT N_("Defines if silence alarm information should be send (default 1)")
+#define SILENCE_LONGTEXT N_("Defines if silence alarm information should be send. "\
+                "1 if the information should be sent, 0 otherwise (default 1)." )
+#define TIME_WINDOW_TEXT N_("Time window to use in ms (default 5000)")
+#define TIME_WINDOW_LONGTEXT N_("Time Window during when the audio level is measured in ms for silence detection. "\
+                "If the audio level is under the threshold during this time, "\
+                "an alarm is sent (default 5000)." )
+#define ALARM_THRESHOLD_TEXT N_("Minimum Audio level to raise the alarm (default 0.1)")
+#define ALARM_THRESHOLD_LONGTEXT N_("Threshold to be attained to raise an alarm. "\
+                "If the audio level is under the threshold during this time, "\
+                "an alarm is sent (default 0.1)." )
+#define REPETITION_TIME_TEXT N_("Time between two alamr messages in ms (default 2000)" )
+#define REPETITION_TIME_LONGTEXT N_("Time between two alarm messages in ms. "\
+                "This value is used to avoid alarm saturation (default 2000)." )
+#define CONNECTION_RESET_TEXT N_("Force connection reset regularly (default 1)" )
+#define CONNECTION_RESET_LONGTEXT N_("Defines if the TCP connection should be reset. "\
+                "This is to be used when using with audiobargraph_v (default 1)." )
+
+#define CFG_PREFIX "audiobargraph_a-"
+
+/*****************************************************************************
+ * Module descriptor
+ *****************************************************************************/
+static int  Open( vlc_object_t * );
+static void Close( vlc_object_t * );
+static block_t *DoWork( filter_t *, block_t * );
+
+vlc_module_begin ()
+    set_description( N_("Audio part of the BarGraph function") )
+    set_shortname( N_("audiobargraph_a") )
+    set_capability( "audio filter", 0 )
+    set_category( CAT_AUDIO )
+    set_subcategory( SUBCAT_AUDIO_AFILTER )
+    
+    add_string( CFG_PREFIX "address", "localhost", NULL, ADDRESS_TEXT, ADDRESS_LONGTEXT, false )
+    add_integer( CFG_PREFIX "port", 12345, NULL, PORT_TEXT, PORT_LONGTEXT, false )
+    add_integer( CFG_PREFIX "bargraph", 1, NULL, BARGRAPH_TEXT, BARGRAPH_LONGTEXT, false )
+    add_integer( CFG_PREFIX "bargraph_repetition", 4, NULL, BARGRAPH_REPETITION_TEXT, BARGRAPH_REPETITION_LONGTEXT, false )
+    add_integer( CFG_PREFIX "silence", 1, NULL, SILENCE_TEXT, SILENCE_LONGTEXT, false )
+    add_integer( CFG_PREFIX "time_window", 5000, NULL, TIME_WINDOW_TEXT, TIME_WINDOW_LONGTEXT, false )
+    add_float( CFG_PREFIX "alarm_threshold", 0.1, NULL, ALARM_THRESHOLD_TEXT, ALARM_THRESHOLD_LONGTEXT, false )
+    add_integer( CFG_PREFIX "repetition_time", 2000, NULL, REPETITION_TIME_TEXT, REPETITION_TIME_LONGTEXT, false )
+    add_integer( CFG_PREFIX "connection_reset", 1, NULL, CONNECTION_RESET_TEXT, CONNECTION_RESET_LONGTEXT, false )
+    
+    set_callbacks( Open, Close )
+vlc_module_end ()
+
+typedef struct ValueDate_t {
+    float value;
+    mtime_t date;
+    struct ValueDate_t* next;
+} ValueDate_t;
+
+struct filter_sys_t
+{
+    char*           address;
+    int             port;
+    int             bargraph;
+    int             bargraph_repetition;
+    int             silence;
+    int             time_window;
+    float           alarm_threshold;
+    int             repetition_time;
+    int             connection_reset;
+    int             TCPconnection;
+    int             counter;
+    int             nbChannels;
+    ValueDate_t*    first;
+    ValueDate_t*    last;
+    int             started;
+    mtime_t         lastAlarm;
+};
+
+/*****************************************************************************
+ * Open: open the visualizer
+ *****************************************************************************/
+static int Open( vlc_object_t *p_this )
+{
+    filter_t     *p_filter = (filter_t *)p_this;
+    filter_sys_t *p_sys;
+
+    if ( !AOUT_FMTS_SIMILAR( &p_filter->fmt_in.audio, &p_filter->fmt_out.audio ) )
+    {
+        msg_Err( p_filter, "input and output formats are not similar" );
+        return VLC_EGENERIC;
+    }
+
+    if( p_filter->fmt_in.audio.i_format != VLC_CODEC_FL32 ||
+        p_filter->fmt_out.audio.i_format != VLC_CODEC_FL32 )
+    {
+        p_filter->fmt_in.audio.i_format = VLC_CODEC_FL32;
+        p_filter->fmt_out.audio.i_format = VLC_CODEC_FL32;
+        msg_Warn( p_filter, "bad input or output format" );
+    }
+
+    p_filter->pf_audio_filter = DoWork;
+
+    p_sys = p_filter->p_sys = malloc( sizeof( *p_sys ) );
+    if( !p_sys )
+        return VLC_ENOMEM;
+        
+    p_sys->bargraph = var_CreateGetIntegerCommand( p_filter, "audiobargraph_a-bargraph" );
+    p_sys->bargraph_repetition = var_CreateGetIntegerCommand( p_filter, "audiobargraph_a-bargraph_repetition" );
+    p_sys->silence = var_CreateGetIntegerCommand( p_filter, "audiobargraph_a-silence" );
+    p_sys->address = var_CreateGetStringCommand( p_filter, "audiobargraph_a-address" );
+    p_sys->port = var_CreateGetIntegerCommand( p_filter, "audiobargraph_a-port" );
+    p_sys->time_window = var_CreateGetIntegerCommand( p_filter, "audiobargraph_a-time_window" );
+    p_sys->alarm_threshold = var_CreateGetFloatCommand( p_filter, "audiobargraph_a-alarm_threshold" );
+    p_sys->repetition_time = var_CreateGetIntegerCommand( p_filter, "audiobargraph_a-repetition_time" );
+    p_sys->connection_reset = var_CreateGetIntegerCommand( p_filter, "audiobargraph_a-connection_reset" );
+    if ((p_sys->TCPconnection = net_ConnectTCP(p_this,p_sys->address,p_sys->port)) == -1) {
+        free(p_sys);
+        return VLC_EGENERIC;
+    }
+    p_sys->counter = 0;
+    p_sys->nbChannels = 0;
+    p_sys->first = NULL;
+    p_sys->last = NULL;
+    p_sys->started = 0;
+    p_sys->lastAlarm = 0;
+
+    return VLC_SUCCESS;
+}
+
+/*****************************************************************************
+ * DoWork: treat an audio buffer
+ ****************************************************************************/
+static block_t *DoWork( filter_t *p_filter, block_t *p_in_buf )
+{
+    filter_sys_t *p_sys = p_filter->p_sys;
+    int i, j;
+    float *p_sample = (float *)p_in_buf->p_buffer;
+    float *i_value = NULL;
+    float ch;
+    float max = 0.0;
+    //char *message = (char*)malloc(255*sizeof(char));
+    char message[255];
+    int nbChannels = 0;
+    ValueDate_t* new = NULL;
+    ValueDate_t* current = NULL;
+    float sum;
+    int count = 0;
+    int i_ret;
+    
+    nbChannels = aout_FormatNbChannels( &p_filter->fmt_in.audio );
+    p_sys->nbChannels = nbChannels;
+    
+    i_value = (float*)malloc(nbChannels * sizeof(float));
+    
+    for (i=0; i<nbChannels; i++) {
+        i_value[i] = 0;
+    }
+    
+    /* 1 - Compute the peack values */
+    for ( i = 0 ; i < (int)(p_in_buf->i_nb_samples); i++ )
+    {
+        for (j=0; j<nbChannels; j++) {
+            ch = (*p_sample++);
+            if (ch > i_value[j])
+                i_value[j] = ch;
+            if (ch > max)
+                max = ch;
+        }
+    }
+    max = pow( max, 2 );
+    
+    if (p_sys->silence) {
+        /* 2 - store the new value */
+        new = (ValueDate_t*)malloc(sizeof(ValueDate_t));
+        new->value = max;
+        new->date = p_in_buf->i_pts;
+        new->next = NULL;
+        if (p_sys->last != NULL) {
+            p_sys->last->next = new;
+        }
+        p_sys->last = new;
+        if (p_sys->first == NULL) {
+            p_sys->first = new;
+        }
+        
+        /* 3 - delete too old values */
+        while (p_sys->first->date < (new->date - (p_sys->time_window*1000))) {
+            p_sys->started = 1; // we have enough values to compute a valid total
+            current = p_sys->first;
+            p_sys->first = p_sys->first->next;
+            free(current);
+        }
+        
+        /* If last message was sent enough time ago */
+        if ((p_sys->started) && (p_in_buf->i_pts > p_sys->lastAlarm + (p_sys->repetition_time*1000))) {
+            
+            /* 4 - compute the RMS */
+            current = p_sys->first;
+            sum = 0.0;
+            while (current != NULL) {
+                sum += current->value;
+                count ++;
+                current = current->next;
+            }
+            sum = sum / count;
+            sum = sqrt(sum);
+        
+            /* 5 - compare it to the threshold */
+            if (sum < p_sys->alarm_threshold) {
+                i=1;
+            } else {
+                i=0;
+            }
+            snprintf(message,255,"@audiobargraph_v audiobargraph_v-alarm %d\n",i);
+            
+            msg_Dbg( p_filter, "message alarm : %s", message );
+            //TCPconnection = net_ConnectTCP(p_filter,p_sys->address,p_sys->port);
+            net_Write(p_filter, p_sys->TCPconnection, NULL, message, strlen(message));
+            //net_Close(TCPconnection);
+            
+            p_sys->lastAlarm = p_in_buf->i_pts;
+        }
+    }
+
+    /*for (i=0; i<nbChannels; i++) {
+        value[i] = abs(i_value[i]*100);
+        if ( value[i] > p_sys->value[i] - 6 )
+            p_sys->value[i] = value[i];
+        else
+            p_sys->value[i] = p_sys->value[i] - 6;
+    }*/
+    
+    if (p_sys->bargraph) {
+        /* 6 - sent the message with the values for the BarGraph */
+        if ((nbChannels > 0) && (p_sys->counter%(p_sys->bargraph_repetition) == 0)) {
+            j=snprintf(message,255,"@audiobargraph_v audiobargraph_v-i_values ");
+            for (i=0; i<(nbChannels-1); i++) {
+                j+=snprintf(message+j,255,"%f:", i_value[i]);
+            }
+            snprintf(message+j,255,"%f\n", i_value[nbChannels-1]);
+            msg_Dbg( p_filter, "message values : %s", message );
+
+            //test = send(p_sys->TCPconnection,message,strlen(message),0);
+            //net_Write(p_filter, p_sys->TCPconnection, NULL, message, strlen(message));
+
+            i_ret= net_Write(p_filter, p_sys->TCPconnection, NULL, message, strlen(message));
+
+        }
+    }
+    
+    free(i_value);
+    
+    if (p_sys->counter > p_sys->bargraph_repetition*100) {
+        if (p_sys->connection_reset) {
+            net_Close(p_sys->TCPconnection);
+            p_sys->TCPconnection = net_ConnectTCP(p_filter,p_sys->address,p_sys->port);
+        }
+        p_sys->counter = 0;
+    }
+    
+    //free(message);
+    p_sys->counter++;
+    
+    return p_in_buf;
+}
+
+/*****************************************************************************
+ * Close: close the plugin
+ *****************************************************************************/
+static void Close( vlc_object_t *p_this )
+{
+    filter_t * p_filter = (filter_t *)p_this;
+    filter_sys_t *p_sys = p_filter->p_sys;
+    ValueDate_t* current;
+    
+    p_sys->last = NULL;
+    while (p_sys->first != NULL) {
+        current = p_sys->first;
+        p_sys->first = p_sys->first->next;
+        free(current);
+    }
+    net_Close(p_sys->TCPconnection);
+    free(p_sys->address);
+    //free(p_sys->value);
+    free( p_filter->p_sys );
+}
diff --git a/modules/video_filter/Modules.am b/modules/video_filter/Modules.am
index 7032375..909d5b9 100644
--- a/modules/video_filter/Modules.am
+++ b/modules/video_filter/Modules.am
@@ -9,6 +9,7 @@ SOURCES_clone = clone.c
 SOURCES_crop = crop.c
 SOURCES_motionblur = motionblur.c
 SOURCES_logo = logo.c
+SOURCES_audiobargraph_v = audiobargraph_v.c
 SOURCES_deinterlace = deinterlace.c yadif.h
 SOURCES_blend = blend.c
 SOURCES_scale = scale.c
diff --git a/modules/video_filter/audiobargraph_v.c b/modules/video_filter/audiobargraph_v.c
new file mode 100755
index 0000000..269fed2
--- /dev/null
+++ b/modules/video_filter/audiobargraph_v.c
@@ -0,0 +1,948 @@
+/*****************************************************************************
+ * audiobargraph_v.c : audiobargraph video plugin for vlc
+ *****************************************************************************
+ * Copyright (C) 2003-2006 the VideoLAN team
+ *
+ * Authors: Clement CHESNIN <clement.chesnin@gmail.com>
+ *          Philippe COENT <philippe.coent@tdf.fr>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+/*****************************************************************************
+ * Preamble
+ *****************************************************************************/
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+#include <assert.h>
+#include <string.h>
+
+#include <vlc_common.h>
+#include <vlc_plugin.h>
+#include <vlc_filter.h>
+
+#include <vlc_image.h>
+#include <vlc_osd.h>
+
+#ifdef LoadImage
+#   undef LoadImage
+#endif
+
+/*****************************************************************************
+ * Module descriptor
+ *****************************************************************************/
+ 
+#define I_VALUES_TEXT N_("Value of the audio channels levels")
+#define I_VALUES_LONGTEXT N_("Value of the audio level of each channels between 0 and 1" \
+    "Each level should be separated with ':'.")
+#define POSX_TEXT N_("X coordinate")
+#define POSX_LONGTEXT N_("X coordinate of the bargraph." )
+#define POSY_TEXT N_("Y coordinate")
+#define POSY_LONGTEXT N_("Y coordinate of the bargraph." )
+#define TRANS_TEXT N_("Transparency of the bargraph")
+#define TRANS_LONGTEXT N_("Bargraph transparency value " \
+  "(from 0 for full transparency to 255 for full opacity)." )
+#define POS_TEXT N_("Bargraph position")
+#define POS_LONGTEXT N_( \
+  "Enforce the bargraph position on the video " \
+  "(0=center, 1=left, 2=right, 4=top, 8=bottom, you can " \
+  "also use combinations of these values, eg 6 = top-right).")
+#define ALARM_TEXT N_("Alarm")
+#define ALARM_LONGTEXT N_("Signals a silence and displays and alert " \
+                "(0=no alarm, 1=alarm).")
+#define BARWIDTH_TEXT N_("Bar width in pixel (default : 10)")
+#define BARWIDTH_LONGTEXT N_("Width in pixel of each bar in the BarGraph to be displayed " \
+                "(default : 10).")
+
+#define CFG_PREFIX "audiobargraph_v-"
+
+static const int pi_pos_values[] = { 0, 1, 2, 4, 8, 5, 6, 9, 10 };
+static const char *const ppsz_pos_descriptions[] =
+{ N_("Center"), N_("Left"), N_("Right"), N_("Top"), N_("Bottom"),
+  N_("Top-Left"), N_("Top-Right"), N_("Bottom-Left"), N_("Bottom-Right") };
+
+static int  OpenSub  ( vlc_object_t * );
+static int  OpenVideo( vlc_object_t * );
+static void Close    ( vlc_object_t * );
+
+vlc_module_begin ()
+
+    set_category( CAT_VIDEO )
+    set_subcategory( SUBCAT_VIDEO_SUBPIC )
+
+    set_capability( "sub filter", 0 )
+    set_callbacks( OpenSub, Close )
+    set_description( N_("Audio Bar Graph Video sub filter") )
+    set_shortname( N_("Audio Bar Graph Video") )
+    add_shortcut( "audiobargraph_v" )
+
+    add_string( CFG_PREFIX "i_values", NULL, NULL, I_VALUES_TEXT, I_VALUES_LONGTEXT, false )
+    add_integer( CFG_PREFIX "x", 0, NULL, POSX_TEXT, POSX_LONGTEXT, true )
+    add_integer( CFG_PREFIX "y", 0, NULL, POSY_TEXT, POSY_LONGTEXT, true )
+    add_integer_with_range( CFG_PREFIX "transparency", 255, 0, 255, NULL,
+        TRANS_TEXT, TRANS_LONGTEXT, false )
+    add_integer( CFG_PREFIX "position", -1, NULL, POS_TEXT, POS_LONGTEXT, false )
+        change_integer_list( pi_pos_values, ppsz_pos_descriptions, NULL )
+    add_integer( CFG_PREFIX "alarm", 0, NULL, ALARM_TEXT, ALARM_LONGTEXT, true )
+    add_integer( CFG_PREFIX "barWidth", 10, NULL, BARWIDTH_TEXT, BARWIDTH_LONGTEXT, true )
+
+    /* video output filter submodule */
+    add_submodule ()
+    set_capability( "video filter2", 0 )
+    set_callbacks( OpenVideo, Close )
+    set_description( N_("Audio Bar Graph Video sub filter") )
+    add_shortcut( "audiobargraph_v" )
+vlc_module_end ()
+
+
+/*****************************************************************************
+ * Local prototypes
+ *****************************************************************************/
+
+/*****************************************************************************
+ * Structure to hold the Bar Graph properties
+ ****************************************************************************/
+typedef struct
+{
+    int i_alpha;       /* -1 means use default alpha */
+    int nbChannels;
+    int *i_values;
+    picture_t *p_pic;
+    mtime_t date;
+    int scale;
+    int alarm;
+    int barWidth;
+
+} BarGraph_t;
+
+/**
+ * Private data holder
+ */
+struct filter_sys_t
+{
+    filter_t *p_blend;
+
+    vlc_mutex_t lock;
+    
+    BarGraph_t p_BarGraph;
+
+    int i_pos;
+    int i_pos_x;
+    int i_pos_y;
+    bool b_absolute;
+
+    /* On the fly control variable */
+    bool b_spu_update;
+};
+
+static const char *const ppsz_filter_options[] = {
+    "i_values", "x", "y", "transparency", "position", "alarm", "barWidth", NULL
+};
+
+static const char *const ppsz_filter_callbacks[] = {
+    "audiobargraph_v-i_values",
+    "audiobargraph_v-x",
+    "audiobargraph_v-y",
+    "audiobargraph_v-transparency",
+    "audiobargraph_v-position",
+    "audiobargraph_v-alarm",
+    "audiobargraph_v-barWidth",
+    NULL
+};
+
+static int OpenCommon( vlc_object_t *, bool b_sub );
+
+static subpicture_t *FilterSub( filter_t *, mtime_t );
+static picture_t    *FilterVideo( filter_t *, picture_t * );
+
+static int BarGraphCallback( vlc_object_t *, char const *,
+                         vlc_value_t, vlc_value_t, void * );
+
+static void LoadBarGraph( vlc_object_t *, BarGraph_t *);
+void parse_i_values( BarGraph_t *p_BarGraph, char *i_values);
+
+/**
+ * Open the sub filter
+ */
+static int OpenSub( vlc_object_t *p_this )
+{
+    return OpenCommon( p_this, true );
+}
+
+/**
+ * Open the video filter
+ */
+static int OpenVideo( vlc_object_t *p_this )
+{
+    return OpenCommon( p_this, false );
+}
+
+/**
+ * Common open function
+ */
+static int OpenCommon( vlc_object_t *p_this, bool b_sub )
+{
+    filter_t *p_filter = (filter_t *)p_this;
+    filter_sys_t *p_sys;
+    BarGraph_t *p_BarGraph;
+    char* i_values = NULL;
+
+    /* */
+    if( !b_sub && !es_format_IsSimilar( &p_filter->fmt_in, &p_filter->fmt_out ) )
+    {
+        msg_Err( p_filter, "Input and output format does not match" );
+        return VLC_EGENERIC;
+    }
+
+
+    /* */
+    p_filter->p_sys = p_sys = malloc( sizeof( *p_sys ) );
+    if( !p_sys )
+        return VLC_ENOMEM;
+    p_BarGraph = &(p_sys->p_BarGraph);
+
+    /* */
+    p_sys->p_blend = NULL;
+    if( !b_sub )
+    {
+
+        p_sys->p_blend = filter_NewBlend( VLC_OBJECT(p_filter),
+                                          &p_filter->fmt_in.video );
+        if( !p_sys->p_blend )
+        {
+            //free( p_BarGraph );
+            free( p_sys );
+            return VLC_EGENERIC;
+        }
+    }
+
+    /* */
+    config_ChainParse( p_filter, CFG_PREFIX, ppsz_filter_options,
+                       p_filter->p_cfg );
+
+    /* create and initialize variables */
+    p_sys->i_pos = var_CreateGetIntegerCommand( p_filter, "audiobargraph_v-position" );
+    p_sys->i_pos_x = var_CreateGetIntegerCommand( p_filter, "audiobargraph_v-x" );
+    p_sys->i_pos_y = var_CreateGetIntegerCommand( p_filter, "audiobargraph_v-y" );
+    p_BarGraph->i_alpha = var_CreateGetIntegerCommand( p_filter,
+                                                        "audiobargraph_v-transparency" );
+    p_BarGraph->i_alpha = __MAX( __MIN( p_BarGraph->i_alpha, 255 ), 0 );
+    i_values = var_CreateGetStringCommand( p_filter, "audiobargraph_v-i_values" );
+    //p_BarGraph->nbChannels = 0;
+    //p_BarGraph->i_values = NULL;
+    parse_i_values(p_BarGraph, i_values);
+    p_BarGraph->alarm = var_CreateGetIntegerCommand( p_filter, "audiobargraph_v-alarm" );
+    p_BarGraph->barWidth = var_CreateGetIntegerCommand( p_filter, "audiobargraph_v-barWidth" );
+    p_BarGraph->scale = 400;
+
+    /* Ignore aligment if a position is given for video filter */
+    if( !b_sub && p_sys->i_pos_x >= 0 && p_sys->i_pos_y >= 0 )
+        p_sys->i_pos = 0;
+
+    vlc_mutex_init( &p_sys->lock );
+    LoadBarGraph( p_this, p_BarGraph );
+    p_sys->b_spu_update = true;
+
+    for( int i = 0; ppsz_filter_callbacks[i]; i++ )
+        var_AddCallback( p_filter, ppsz_filter_callbacks[i],
+                         BarGraphCallback, p_sys );
+
+    /* Misc init */
+    if( b_sub )
+    {
+        p_filter->pf_sub_filter = FilterSub;
+    }
+    else
+    {
+        p_filter->pf_video_filter = FilterVideo;
+    }
+
+    free( i_values );
+    return VLC_SUCCESS;
+}
+
+/**
+ * Common close function
+ */
+static void Close( vlc_object_t *p_this )
+{
+    filter_t *p_filter = (filter_t *)p_this;
+    filter_sys_t *p_sys = p_filter->p_sys;
+    BarGraph_t *p_BarGraph = &(p_sys->p_BarGraph);
+
+    for( int i = 0; ppsz_filter_callbacks[i]; i++ )
+        var_DelCallback( p_filter, ppsz_filter_callbacks[i],
+                         BarGraphCallback, p_sys );
+
+    if( p_sys->p_blend )
+        filter_DeleteBlend( p_sys->p_blend );
+
+    vlc_mutex_destroy( &p_sys->lock );
+    
+    if( p_BarGraph->p_pic )
+    {
+        picture_Release( p_BarGraph->p_pic );
+        p_BarGraph->p_pic = NULL;
+    }
+    free( p_BarGraph->i_values );
+    
+    free( p_sys );
+}
+
+/**
+ * Sub filter
+ */
+static subpicture_t *FilterSub( filter_t *p_filter, mtime_t date )
+{
+    filter_sys_t *p_sys = p_filter->p_sys;
+    BarGraph_t *p_BarGraph = &(p_sys->p_BarGraph);
+
+    subpicture_t *p_spu;
+    subpicture_region_t *p_region;
+    video_format_t fmt;
+    picture_t *p_pic;
+
+    vlc_mutex_lock( &p_sys->lock );
+    /* Basic test:  b_spu_update occurs on a dynamic change */
+    if( !p_sys->b_spu_update )
+    {
+        vlc_mutex_unlock( &p_sys->lock );
+        return 0;
+    }
+
+    p_pic = p_BarGraph->p_pic;
+
+    /* Allocate the subpicture internal data. */
+    p_spu = filter_NewSubpicture( p_filter );
+    if( !p_spu )
+        goto exit;
+
+    p_spu->b_absolute = p_sys->b_absolute;
+    p_spu->i_start = date;
+    p_spu->i_stop = 0;
+    p_spu->b_ephemer = true;
+
+    /* Send an empty subpicture to clear the display when needed */
+    if( !p_pic || !p_BarGraph->i_alpha )
+        goto exit;
+
+    /* Create new SPU region */
+    memset( &fmt, 0, sizeof(video_format_t) );
+    fmt.i_chroma = VLC_CODEC_YUVA;
+    fmt.i_aspect = VOUT_ASPECT_FACTOR;
+    fmt.i_sar_num = fmt.i_sar_den = 1;
+    fmt.i_width = fmt.i_visible_width = p_pic->p[Y_PLANE].i_visible_pitch;
+    fmt.i_height = fmt.i_visible_height = p_pic->p[Y_PLANE].i_visible_lines;
+    fmt.i_x_offset = fmt.i_y_offset = 0;
+    p_region = subpicture_region_New( &fmt );
+    if( !p_region )
+    {
+        msg_Err( p_filter, "cannot allocate SPU region" );
+        p_filter->pf_sub_buffer_del( p_filter, p_spu );
+        p_spu = NULL;
+        goto exit;
+    }
+
+    /* */
+    picture_Copy( p_region->p_picture, p_pic );
+
+    /*  where to locate the bar graph: */
+    if( p_sys->i_pos < 0 )
+    {   /*  set to an absolute xy */
+        p_region->i_align = OSD_ALIGN_RIGHT | OSD_ALIGN_TOP;
+        p_spu->b_absolute = true;
+    }
+    else
+    {   /* set to one of the 9 relative locations */
+        p_region->i_align = p_sys->i_pos;
+        p_spu->b_absolute = false;
+    }
+
+    p_region->i_x = p_sys->i_pos_x;
+    p_region->i_y = p_sys->i_pos_y;
+
+    p_spu->p_region = p_region;
+
+    p_spu->i_alpha = p_BarGraph->i_alpha ;
+
+exit:
+    vlc_mutex_unlock( &p_sys->lock );
+
+    return p_spu;
+}
+
+/**
+ * Video filter
+ */
+static picture_t *FilterVideo( filter_t *p_filter, picture_t *p_src )
+{
+    filter_sys_t *p_sys = p_filter->p_sys;
+    BarGraph_t *p_BarGraph = &(p_sys->p_BarGraph);
+
+    picture_t *p_dst = filter_NewPicture( p_filter );
+    if( !p_dst )
+        goto exit;
+
+    picture_Copy( p_dst, p_src );
+
+    /* */
+    vlc_mutex_lock( &p_sys->lock );
+
+    /* */
+    const picture_t *p_pic = p_BarGraph->p_pic;
+    if( p_pic )
+    {
+        const video_format_t *p_fmt = &p_pic->format;
+        const int i_dst_w = p_filter->fmt_out.video.i_visible_width;
+        const int i_dst_h = p_filter->fmt_out.video.i_visible_height;
+
+        if( p_sys->i_pos )
+        {
+            if( p_sys->i_pos & SUBPICTURE_ALIGN_BOTTOM )
+            {
+                p_sys->i_pos_y = i_dst_h - p_fmt->i_visible_height;
+            }
+            else if ( !(p_sys->i_pos & SUBPICTURE_ALIGN_TOP) )
+            {
+                p_sys->i_pos_y = ( i_dst_h - p_fmt->i_visible_height ) / 2;
+            }
+            else
+            {
+                p_sys->i_pos_y = 0;
+            }
+
+            if( p_sys->i_pos & SUBPICTURE_ALIGN_RIGHT )
+            {
+                p_sys->i_pos_x = i_dst_w - p_fmt->i_visible_width;
+            }
+            else if ( !(p_sys->i_pos & SUBPICTURE_ALIGN_LEFT) )
+            {
+                p_sys->i_pos_x = ( i_dst_w - p_fmt->i_visible_width ) / 2;
+            }
+            else
+            {
+                p_sys->i_pos_x = 0;
+            }
+        }
+
+        /* */
+        const int i_alpha = p_BarGraph->i_alpha;
+        if( filter_ConfigureBlend( p_sys->p_blend, i_dst_w, i_dst_h, p_fmt ) ||
+            filter_Blend( p_sys->p_blend, p_dst, p_sys->i_pos_x, p_sys->i_pos_y,
+                          p_pic, i_alpha ) )
+        {
+            msg_Err( p_filter, "failed to blend a picture" );
+        }
+    }
+    vlc_mutex_unlock( &p_sys->lock );
+
+exit:
+    picture_Release( p_src );
+    return p_dst;
+}
+
+/*****************************************************************************
+ * Callback to update params on the fly
+ *****************************************************************************/
+static int BarGraphCallback( vlc_object_t *p_this, char const *psz_var,
+                         vlc_value_t oldval, vlc_value_t newval, void *p_data )
+{
+    VLC_UNUSED(oldval);
+    filter_sys_t *p_sys = (filter_sys_t *)p_data;
+    BarGraph_t *p_BarGraph = &(p_sys->p_BarGraph);
+    char* i_values;
+    char* res = NULL;
+
+    vlc_mutex_lock( &p_sys->lock );
+    if ( !strcmp( psz_var, "audiobargraph_v-x" ) )
+    {
+        p_sys->i_pos_x = newval.i_int;
+    }
+    else if ( !strcmp( psz_var, "audiobargraph_v-y" ) )
+    {
+        p_sys->i_pos_y = newval.i_int;
+    }
+    else if ( !strcmp( psz_var, "audiobargraph_v-position" ) )
+    {
+        p_sys->i_pos = newval.i_int;
+    }
+    else if ( !strcmp( psz_var, "audiobargraph_v-transparency" ) )
+    {
+        p_BarGraph->i_alpha = __MAX( __MIN( newval.i_int, 255 ), 0 );
+    }
+    else if ( !strcmp( psz_var, "audiobargraph_v-i_values" ) )
+    {
+        if( p_BarGraph->p_pic )
+        {
+            picture_Release( p_BarGraph->p_pic );
+            p_BarGraph->p_pic = NULL;
+        }
+        i_values = strdup( newval.psz_string );
+        free(p_BarGraph->i_values);
+        //p_BarGraph->i_values = NULL;
+        //p_BarGraph->nbChannels = 0;
+        // in case many answer are received at the same time, only keep one
+        res = strchr(i_values, '@');
+        if (res)
+            *res = 0;
+        parse_i_values( p_BarGraph, i_values);
+        LoadBarGraph(p_this,p_BarGraph);
+    }
+    else if ( !strcmp( psz_var, "audiobargraph_v-alarm" ) )
+    {
+        if( p_BarGraph->p_pic )
+        {
+            picture_Release( p_BarGraph->p_pic );
+            p_BarGraph->p_pic = NULL;
+        }
+        p_BarGraph->alarm = newval.i_int;
+        LoadBarGraph(p_this,p_BarGraph);
+    }
+    else if ( !strcmp( psz_var, "audiobargraph_v-barWidth" ) )
+    {
+        if( p_BarGraph->p_pic )
+        {
+            picture_Release( p_BarGraph->p_pic );
+            p_BarGraph->p_pic = NULL;
+        }
+        p_BarGraph->barWidth = newval.i_int;
+        LoadBarGraph(p_this,p_BarGraph);
+    }
+    p_sys->b_spu_update = true;
+    vlc_mutex_unlock( &p_sys->lock );
+
+    return VLC_SUCCESS;
+}
+
+/*****************************************************************************
+ * LoadImage: creates and returns the bar graph image
+ *****************************************************************************/
+static picture_t *LoadImage( vlc_object_t *p_this, int nbChannels, int* i_values, int scale, int alarm, int barWidth)
+{
+    VLC_UNUSED(p_this);
+    picture_t *p_pic;
+    int i,j;
+    int i_width = 0;
+    int i_line;
+    int moinsTrois, moinsCinq, moinsSept, moinsDix, moinsVingt;
+    
+    if (nbChannels == 0) {
+        i_width = 20;
+    } else {
+        i_width = 2 * nbChannels * barWidth + 10;
+    }
+    
+    moinsTrois = 0.71*scale + 20;
+    moinsCinq = 0.56*scale + 20;
+    moinsSept = 0.45*scale + 20;
+    moinsDix = 0.32*scale + 20;
+    moinsVingt = 0.1*scale + 20;
+    
+    p_pic = picture_New(VLC_FOURCC('Y','U','V','A'), i_width+20, scale+30, VOUT_ASPECT_FACTOR * (i_width+20)/(scale+30));
+    
+    // blacken the whole picture
+    for( i = 0 ; i < p_pic->i_planes ; i++ )
+    {
+        memset( p_pic->p[i].p_pixels, 0x00,
+                p_pic->p[i].i_visible_lines * p_pic->p[i].i_pitch );
+    }
+    
+    // side bar
+    for ( i_line = 20; i_line < scale+20; i_line++ ) {
+    
+#define DrawPointsBlack(a,b) {\
+        for (i=a; i<b; i++) {\
+            *(p_pic->p[0].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[0].i_pitch + i ) = 0x00; \
+            *(p_pic->p[1].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[1].i_pitch + i ) = 128; \
+            *(p_pic->p[2].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[2].i_pitch + i ) = 128; \
+            *(p_pic->p[3].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[3].i_pitch + i ) = 0xFF; \
+        }\
+    }
+#define DrawPointsWhite(a,b) {\
+        for (i=a; i<b; i++) {\
+            *(p_pic->p[0].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[0].i_pitch + i ) = 0xFF;\
+            *(p_pic->p[1].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[1].i_pitch + i ) = 128;\
+            *(p_pic->p[2].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[2].i_pitch + i ) = 128;\
+            *(p_pic->p[3].p_pixels + (scale + 30 - i_line - 1) * p_pic->p[3].i_pitch + i ) = 0xFF; \
+        }\
+    }    
+        
+        // vertical line
+        DrawPointsBlack(20,22);
+        DrawPointsWhite(22,24);
+    
+        // -3dB
+        if (i_line == moinsTrois - 2) {
+            // 3
+            DrawPointsBlack(16,19);
+        }
+        if (i_line == moinsTrois - 1) {
+            // 3
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsWhite(24,27);
+        }
+        if (i_line == moinsTrois) {
+            // 3
+            DrawPointsBlack(16,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsTrois + 1) {
+            // 3
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsTrois + 2) {
+            // 3
+            DrawPointsBlack(16,19);
+        }
+        
+        // -5dB
+        if (i_line == moinsCinq - 2) {
+            // 5
+            DrawPointsBlack(16,19);
+        }
+        if (i_line == moinsCinq - 1) {
+            // 5
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsWhite(24,27);
+        }
+        if (i_line == moinsCinq) {
+            // 5
+            DrawPointsBlack(16,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsCinq + 1) {
+            // 5
+            DrawPointsBlack(16,17);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsCinq + 2) {
+            // 5
+            DrawPointsBlack(16,19);
+        }
+        
+        // -7dB
+        if (i_line == moinsSept - 2) {
+            // 7
+            DrawPointsBlack(18,19);
+        }
+        if (i_line == moinsSept - 1) {
+            // 7
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsWhite(24,27);
+        }
+        if (i_line == moinsSept) {
+            // 7
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsSept + 1) {
+            // 7
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsSept + 2) {
+            // 7
+            DrawPointsBlack(16,19);
+        }
+        
+        
+        // -10dB
+        if (i_line == moinsDix - 2) {
+            // 1
+            DrawPointsBlack(14,15);
+            // 0
+            DrawPointsBlack(16,19);
+        }
+        if (i_line == moinsDix - 1) {
+            // 1
+            DrawPointsBlack(14,15);
+            // 0
+            DrawPointsBlack(16,17);
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsWhite(24,27);
+        }
+        if (i_line == moinsDix) {
+            // 1
+            DrawPointsBlack(14,15);
+            // 0
+            DrawPointsBlack(16,17);
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsDix + 1) {
+            // 1
+            DrawPointsBlack(14,15);
+            // 0
+            DrawPointsBlack(16,17);
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsDix + 2) {
+            // 1
+            DrawPointsBlack(14,15);
+            // 0
+            DrawPointsBlack(16,19);
+        }
+        
+        // -20dB
+        if (i_line == moinsVingt - 2) {
+            // 2
+            DrawPointsBlack(12,15);
+            // 0
+            DrawPointsBlack(16,19);
+        }
+        if (i_line == moinsVingt - 1) {
+            // 2
+            DrawPointsBlack(12,13);
+            // 0
+            DrawPointsBlack(16,17);
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsWhite(24,27);
+        }
+        if (i_line == moinsVingt) {
+            // 2
+            DrawPointsBlack(12,15);
+            // 0
+            DrawPointsBlack(16,17);
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsVingt + 1) {
+            // 2
+            DrawPointsBlack(14,15);
+            // 0
+            DrawPointsBlack(16,17);
+            DrawPointsBlack(18,19);
+            // limit
+            DrawPointsBlack(24,27);
+        }
+        if (i_line == moinsVingt + 2) {
+            // 2
+            DrawPointsBlack(12,15);
+            // 0
+            DrawPointsBlack(16,19);
+        }
+        
+        
+    }
+    
+    // draw the bars and channel indicators
+    for (i=0; i<nbChannels; i++) {
+        for( j = barWidth+20 ; j < 2*barWidth+20; j++)
+        {
+            // channel indicators
+            for ( i_line = 12; i_line < 18; i_line++ ) {
+                // white
+                *(p_pic->p[0].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[0].i_pitch +
+                    ( (2*i*barWidth)+j ) ) = 255;
+                *(p_pic->p[1].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[1].i_pitch +
+                    ( (2*i*barWidth)+j ) ) = 128;
+                *(p_pic->p[2].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[2].i_pitch +
+                    ( (2*i*barWidth)+j ) ) = 128;
+                *(p_pic->p[3].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[3].i_pitch +
+                    ( (2*i*barWidth)+j )) = 0xFF;
+            }
+            // bars
+            for( i_line = 20; i_line < i_values[i]+20; i_line++ )
+            {
+                if (i_line < moinsDix) { // green if < -10 dB
+                    *(p_pic->p[0].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[0].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 150;
+                    *(p_pic->p[1].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[1].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 44;
+                    *(p_pic->p[2].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[2].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 21;
+                    *(p_pic->p[3].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[3].i_pitch +
+                        ( (2*i*barWidth)+j )) = 0xFF;
+                } else if (i_line < moinsTrois) { // yellow if > -10dB and < -3dB
+                    *(p_pic->p[0].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[0].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 226;
+                    *(p_pic->p[1].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[1].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 1;
+                    *(p_pic->p[2].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[2].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 148;
+                    *(p_pic->p[3].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[3].i_pitch +
+                        ( (2*i*barWidth)+j )) = 0xFF;
+                } else { // red if > -3 dB
+                    *(p_pic->p[0].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[0].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 76;
+                    *(p_pic->p[1].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[1].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 85;
+                    *(p_pic->p[2].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[2].i_pitch +
+                        ( (2*i*barWidth)+j ) ) = 0xFF;
+                    *(p_pic->p[3].p_pixels +
+                        (scale + 30 - i_line - 1) *
+                        p_pic->p[3].i_pitch +
+                        ( (2*i*barWidth)+j )) = 0xFF;
+                }
+            }
+        }
+    }
+    
+    
+    
+    if (alarm) {// draw the alarm square
+        // bottom
+        for ( i_line = 0; i_line < 10; i_line++ ) {
+            for (i=0; i<i_width+20; i++) {
+                *(p_pic->p[0].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[0].i_pitch + i ) = 76;
+                *(p_pic->p[1].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[1].i_pitch + i ) = 85;
+                *(p_pic->p[2].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[2].i_pitch + i ) = 0xFF;
+                *(p_pic->p[3].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[3].i_pitch + i ) = 0xFF;
+            }
+        }
+        // top
+        for ( i_line = scale+21; i_line < scale+30; i_line++ ) {
+            for (i=0; i<i_width+20; i++) {
+                *(p_pic->p[0].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[0].i_pitch + i ) = 76;
+                *(p_pic->p[1].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[1].i_pitch + i ) = 85;
+                *(p_pic->p[2].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[2].i_pitch + i ) = 0xFF;
+                *(p_pic->p[3].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[3].i_pitch + i ) = 0xFF;
+            }
+        }
+        // sides
+        for ( i_line = 9; i_line < scale+21; i_line++ ) {
+            for (i=0; i<10; i++) {
+                *(p_pic->p[0].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[0].i_pitch + i ) = 76;
+                *(p_pic->p[1].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[1].i_pitch + i ) = 85;
+                *(p_pic->p[2].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[2].i_pitch + i ) = 0xFF;
+                *(p_pic->p[3].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[3].i_pitch + i ) = 0xFF;
+            }
+            for (i=i_width+11; i<i_width+20; i++) {
+                *(p_pic->p[0].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[0].i_pitch + i ) = 76;
+                *(p_pic->p[1].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[1].i_pitch + i ) = 85;
+                *(p_pic->p[2].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[2].i_pitch + i ) = 0xFF;
+                *(p_pic->p[3].p_pixels +
+                    (scale + 30 - i_line - 1) *
+                    p_pic->p[3].i_pitch + i ) = 0xFF;
+            }
+        }
+    }
+    
+
+    return p_pic;
+}
+
+/*****************************************************************************
+ * LoadBarGraph: loads the BarGraph images into memory
+ *****************************************************************************/
+static void LoadBarGraph( vlc_object_t *p_this, BarGraph_t *p_BarGraph )
+{
+
+    p_BarGraph->p_pic = LoadImage( p_this, p_BarGraph->nbChannels, p_BarGraph->i_values, p_BarGraph->scale, p_BarGraph->alarm, p_BarGraph->barWidth);
+    if( !p_BarGraph->p_pic )
+    {
+        msg_Warn( p_this, "error while creating picture" );
+    }
+
+}
+
+/*****************************************************************************
+ * parse_i_values : parse i_values parameter and store the corresponding values
+ *****************************************************************************/
+void parse_i_values( BarGraph_t *p_BarGraph, char *i_values)
+{
+    char* res = NULL;
+    char delim[] = ":";
+    char* tok;
+
+    p_BarGraph->nbChannels = 0;
+    p_BarGraph->i_values = NULL;
+    res = strtok_r(i_values, delim, &tok);
+    while (res != NULL) {
+        p_BarGraph->nbChannels++;
+        p_BarGraph->i_values = (int*)realloc(p_BarGraph->i_values, p_BarGraph->nbChannels*sizeof(int));
+        p_BarGraph->i_values[p_BarGraph->nbChannels-1] = __MAX( __MIN( atof(res)*p_BarGraph->scale, p_BarGraph->scale ), 0 );
+        res = strtok_r(NULL, delim, &tok);
+    }
+
+}
-- 
1.6.1.2

